---
anchors:
  - text: about
    icon: fa-user
  - text: approach
    icon: fa-microscope
  - text: architecture
    icon: fa-sitemap
  - text: usage
    icon: fa-laptop
  - text: muses
    icon: fa-lightbulb
---
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8">
    <meta name="description" content="Mnemosyne is your automated software development assistant.  It integrates with your IDE and works with you suggesting code, types, and tests as you work; and continually checking the consistency of your documentation, types, tests, and implementation &mdash; whether that means running test suites or type checkers, or using ML techniques to ensure your documentation matches your implementation. Mnemosyne applies statistical machine learning, formal methods, and Search Based Software Engineering (SBSE) to enable developers to write higher quality, higher assurance, and more standards compliant code more quickly.  Mnemosyne transcends CI/CD by making live substantive contributions to the software development process as the developer works.">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>{{ title }} | Mnemosyne</title>
    <link rel="stylesheet" href="https://www.w3schools.com/w3css/4/w3.css">
    <link rel="stylesheet" href="//use.fontawesome.com/releases/v5.4.0/css/all.css">
    <link rel="stylesheet" href="https://cdn.plyr.io/3.6.7/plyr.css" />
    <link rel="stylesheet" href={{"/css/prism.css" | url }}>
<style>
a { text-decoration: none; color: #4a708b; }

pre {
    border: 2px solid lightgray;
}

code {
    background-color: rgba(27,31,35,.05);
}

blockquote {
    color: #7f8fa4;
    font-size: inherit;
    padding: 8px 24px;
    margin: 16px 0;
    border-left:3px solid #eaeaea
}

dt {
    font-weight: bold;
    margin-top: 1em;
}

abbr[title], acronym[title] {
    text-decoration-line: underline;
    text-decoration-style: dotted;
}

.highlight{
    background-color: yellow;
}

div.figure {
    float: center;
    text-align: center;
}

div.navigation {
    float:center;
    text-align:center;
}

div.banner {
    float: center;
    text-align: center;
    margin: 0.5em;
    padding: 0.5em;
    background-color: salmon;
    display: inline-block;
}
div.banner-wrapper {
    text-align: center
}
div.banner span {
    float: center;
    text-align: center;
}

.table-of-contents ul {
  list-style-type: none;
}

h1,h2,h3,h4 {
  padding-top: 1.5em;
}

.intro-card h1,h2,h3,h4{
  padding-top: 0;
}

.muse-card h1,h2,h3,h4{
  padding-top: 0;
}

.muse-card li p {
  padding: 0;
  margin: 0;
}

img {
    max-width:100%;
    height:auto;
}

figure figcaption {
    color: #7f8fa4;
    text-align: center;
}

@media (min-width:993px){
  .my-half {width:49.99999%}
}

</style>
  </head>
  <body class="w3-white">

  <!-- Navbar (sit on top) -->
  <div class="w3-top">
    <div class="w3-bar w3-white w3-card" id="myNavbar">
      <a href="{{ "/" | url }}" class="w3-bar-item w3-button" onclick="navbar_hide()">Mnemo</a>
      <!-- Right-sided navbar links -->
      <div class="w3-right w3-hide-small">
        <!-- TODO: For loop. -->
        {% for anchor in anchors %}
        {% assign link = "/" | append: anchor.text %}

        {% if anchor.icon %}
        <a href="{{ link | url }}" class="w3-bar-item w3-button"><i class="fas {{ anchor.icon }}"></i> {{ anchor.text | upcase }}</a>
        {% else %}
        <a href="{{ link | url }}" class="w3-bar-item w3-button">{{ anchor.text | upcase }}</a>
        {% endif %}
        {% endfor %}
      </div>
      <!-- Hide right-floated links on small screens and replace them with a menu icon -->
      <a href="javascript:void(0)" class="w3-bar-item w3-button w3-right w3-hide-large w3-hide-medium" onclick="navbar_toggle()">
        <i class="fa fa-bars"></i>
      </a>
    </div>
  </div>

  <!-- Navbar on small screens -->
  <div id="navDemo" class="w3-bar-block w3-white w3-hide w3-hide-large w3-hide-medium w3-top w3-card" style="margin-top:46px">
    {% for anchor in anchors %}
    {% assign link = "/" | append: anchor.text %}

    <a href="#{{ link | url }}" class="w3-bar-item w3-button w3-padding-large" onclick="navbar_toggle()">{{ anchor.text | upcase }}</a>
    {% endfor %}
  </div>

  <div class="w3-container">
    {{ content | glossary | safe }}
  </div>

  <div class="banner-wrapper">
    <div class="banner">
      <span>
        NOTE: Mnemosyne is in early development and is not yet ready for production use.
      </span>
    </div>
  </div>
  <!-- <script src={{ "/js/prism.js" | url }}></script> -->
  <script src="https://cdn.plyr.io/3.6.7/plyr.js"></script>
  <script>
    // Video player
    const player = new Plyr('#player', {
      title: 'Mnemosyne Integrated Demo',
      muted: true,
      autoplay: false,
      captions: { active:true, language: 'auto', update: false},
      controls: ['play-large', 'play', 'progress', 'current-time', 'mute', 'volume', 'captions', 'settings', 'pip', 'airplay', 'fullscreen'],
    });

    // Used to toggle the menu on small screens when clicking on the menu button
    function navbar_toggle() {
      var x = document.getElementById("navDemo");
      if (x.className.indexOf("w3-show") == -1) {
        x.className += " w3-show";
      } else { 
        x.className = x.className.replace(" w3-show", "");
      }
    }
    function navbar_hide() {
      var x = document.getElementById("navDemo");
      if (x.className.indexOf("w3-show") != -1) {
        x.className = x.className.replace(" w3-show", "");
      }
    }
  </script>

  </body>
</html>
